Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -5786,7 +5744,7 @@
                           ) *                                                  &
                              ( v(k_ppp,j,i) + v(k_mm,j,i) )                    &
-                                      )
-
-                diss_t = - ABS( w_comp ) * rho_air_zw(k) * (                   &
+                                                        )
+
+                diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (             &
                           ( 10.0_wp * ibit17 * adv_mom_5                       &
                        +     3.0_wp * ibit16 * adv_mom_3                       &
@@ -5801,33 +5759,87 @@
                           ) *                                                  &
                              ( v(k_ppp,j,i) - v(k_mm,j,i) )                    &
-                                               )
+                                                                 )
+             ENDDO
+
+!
+!--          Set resolved/turbulent flux at model top to zero (w-level). In case that
+!--          a symmetric behavior between bottom and top shall be guaranteed (closed
+!--          channel flow), the flux at nzt is also set to zero.
+             IF ( symmetry_flag == 1 ) THEN
+                flux_t(nzt) = 0.0_wp
+                diss_t(nzt) = 0.0_wp
+                w_comp(nzt) = 0.0_wp
+             ENDIF
+             flux_t(nzt+1) = 0.0_wp
+             diss_t(nzt+1) = 0.0_wp
+             w_comp(nzt+1) = 0.0_wp
+
+             DO k = nzb+1, nzb_max_l
+
+                flux_d    = flux_t(k-1)
+                diss_d    = diss_t(k-1)
+
+                ibit11 = REAL( IBITS(advc_flags_m(k,j,i),11,1), KIND = wp )
+                ibit10 = REAL( IBITS(advc_flags_m(k,j,i),10,1), KIND = wp )
+                ibit9  = REAL( IBITS(advc_flags_m(k,j,i),9,1),  KIND = wp )
+
+                ibit14 = REAL( IBITS(advc_flags_m(k,j,i),14,1), KIND = wp )
+                ibit13 = REAL( IBITS(advc_flags_m(k,j,i),13,1), KIND = wp )
+                ibit12 = REAL( IBITS(advc_flags_m(k,j,i),12,1), KIND = wp )
+
+                ibit17 = REAL( IBITS(advc_flags_m(k,j,i),17,1), KIND = wp )
+                ibit16 = REAL( IBITS(advc_flags_m(k,j,i),16,1), KIND = wp )
+                ibit15 = REAL( IBITS(advc_flags_m(k,j,i),15,1), KIND = wp )
 !
 !--             Calculate the divergence of the velocity field. A respective
 !--             correction is needed to overcome numerical instabilities caused
 !--             by a not sufficient reduction of divergences near topography.
-                div = ( ( u_comp + gu - ( u(k,j-1,i)   + u(k,j,i)   ) ) * ddx  &
-                     +  ( v_comp      - ( v(k,j,i)     + v(k,j-1,i) ) ) * ddy  &
-                     +  (   w_comp                      * rho_air_zw(k) -      &
-                          ( w(k-1,j-1,i) + w(k-1,j,i) ) * rho_air_zw(k-1)      &
-                        ) * drho_air(k) * ddzw(k)                              &
-                      ) * 0.5_wp
- 
+                div = ( ( ( u_comp(k)     + gu )                               &
+                                       * ( ibit9 + ibit10 + ibit11 )           &
+                - ( u(k,j-1,i)   + u(k,j,i) )                                  &
+                                       * (                                     &
+                        REAL( IBITS(advc_flags_m(k,j,i-1),9,1), KIND = wp )    &
+                      + REAL( IBITS(advc_flags_m(k,j,i-1),10,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_m(k,j,i-1),11,1), KIND = wp )   &
+                                         )                                     &
+                  ) * ddx                                                      &
+               +  ( v_comp(k)                                                  &
+                                       * ( ibit12 + ibit13 + ibit14 )          &
+                - ( v(k,j,i)     + v(k,j-1,i) )                                &
+                                       * (                                     &
+                        REAL( IBITS(advc_flags_m(k,j-1,i),12,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_m(k,j-1,i),13,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_m(k,j-1,i),14,1), KIND = wp )   &
+                                         )                                     &
+                  ) * ddy                                                      &
+               +  ( w_comp(k) * rho_air_zw(k)                                  &
+                                       * ( ibit15 + ibit16 + ibit17 )          &
+                - ( w(k-1,j-1,i) + w(k-1,j,i) ) * rho_air_zw(k-1)              &
+                                       * (                                     &
+                        REAL( IBITS(advc_flags_m(k-1,j,i),15,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_m(k-1,j,i),16,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_m(k-1,j,i),17,1), KIND = wp )   &
+                                         )                                     &
+                   ) * drho_air(k) * ddzw(k)                                   &
+                ) * 0.5_wp
+
+
                 tend(k,j,i) = tend(k,j,i) - (                                  &
-                       ( ( flux_r + diss_r )                                   &
-                     -   ( flux_l + diss_l ) ) * ddx                           &
-                     + ( ( flux_n + diss_n )                                   &
-                     -   ( flux_s + diss_s ) ) * ddy                           &
-                     + ( ( flux_t + diss_t )                                   &
+                       ( ( flux_r(k) + diss_r(k) )                             &
+                     -   ( flux_l_v(k,j,tn) + diss_l_v(k,j,tn) ) ) * ddx       &
+                     + ( ( flux_n(k) + diss_n(k) )                             &
+                     -   ( flux_s_v(k,tn) + diss_s_v(k,tn) ) ) * ddy           &
+                     + ( ( flux_t(k) + diss_t(k) )                             &
                      -   ( flux_d + diss_d ) ) * drho_air(k) * ddzw(k)         &
                                             )  + v(k,j,i) * div
 
 #ifndef _OPENACC
-                swap_flux_x_local_v(k,j) = flux_r
-                swap_diss_x_local_v(k,j) = diss_r
-                swap_flux_y_local_v(k)   = flux_n
-                swap_diss_y_local_v(k)   = diss_n
+!
+!--             Swap fluxes. Note, in the OPENACC case these are computed again.
+                flux_l_v(k,j,tn) = flux_r(k)
+                diss_l_v(k,j,tn) = diss_r(k)
+                flux_s_v(k,tn)   = flux_n(k)
+                diss_s_v(k,tn)   = diss_n(k)
 #endif
-                flux_d                   = flux_t
-                diss_d                   = diss_t
 
 !
@@ -5836,10 +5848,10 @@
                 !$ACC ATOMIC
                 sums_vs2_ws_l(k,tn) = sums_vs2_ws_l(k,tn)                      &
-                + ( flux_n                                                     &
-                    * ( v_comp - 2.0_wp * hom(k,1,2,0)                   )     &
-                    / ( v_comp - gv + SIGN( 1.0E-20_wp, v_comp - gv )    )     &
-               +   diss_n                                                      &
-                    *   ABS( v_comp - 2.0_wp * hom(k,1,2,0)              )     &
-                    / ( ABS( v_comp - gv ) + 1.0E-20_wp                  )     &
+                + ( flux_n(k)                                                  &
+                    * ( v_comp(k) - 2.0_wp * hom(k,1,2,0)                   )  &
+                    / ( v_comp(k) - gv + SIGN( 1.0E-20_wp, v_comp(k) - gv ) )  &
+               +   diss_n(k)                                                   &
+                    *   ABS( v_comp(k) - 2.0_wp * hom(k,1,2,0)              )  &
+                    / ( ABS( v_comp(k) - gv ) + 1.0E-20_wp                  )  &
                   ) *   weight_substep(intermediate_timestep_count)
 !
@@ -5847,19 +5859,81 @@
                 !$ACC ATOMIC
                 sums_wsvs_ws_l(k,tn) = sums_wsvs_ws_l(k,tn)                    &
-                + ( flux_t                                                     &
-                    * ( w_comp - 2.0_wp * hom(k,1,3,0)                   )     &
-                    / ( w_comp + SIGN( 1.0E-20_wp, w_comp )              )     &
-               +   diss_t                                                      &
-                    *   ABS( w_comp - 2.0_wp * hom(k,1,3,0)              )     &
-                    / ( ABS( w_comp ) + 1.0E-20_wp                       )     &
+                + ( flux_t(k)                                                  &
+                    * ( w_comp(k) - 2.0_wp * hom(k,1,3,0)                   )  &
+                    / ( w_comp(k) + SIGN( 1.0E-20_wp, w_comp(k) )           )  &
+               +   diss_t(k)                                                   &
+                    *   ABS( w_comp(k) - 2.0_wp * hom(k,1,3,0)              )  &
+                    / ( ABS( w_comp(k) ) + 1.0E-20_wp                       )  &
                   ) *   weight_substep(intermediate_timestep_count)
 
              ENDDO
+
+             DO  k = nzb_max_l+1, nzt
+
+                flux_d    = flux_t(k-1)
+                diss_d    = diss_t(k-1)
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities caused
+!--             by a not sufficient reduction of divergences near topography.
+                div = ( ( u_comp(k) + gu - ( u(k,j-1,i)  + u(k,j,i)   ) ) * ddx&
+                     +  ( v_comp(k)      - ( v(k,j,i)    + v(k,j-1,i) ) ) * ddy&
+                     +  ( w_comp(k)                     * rho_air_zw(k) -      &
+                          ( w(k-1,j-1,i) + w(k-1,j,i) ) * rho_air_zw(k-1)      &
+                        ) * drho_air(k) * ddzw(k)                              &
+                      ) * 0.5_wp
+
+                tend(k,j,i) = tend(k,j,i) - (                                  &
+                       ( ( flux_r(k) + diss_r(k) )                             &
+                     -   ( flux_l_v(k,j,tn) + diss_l_v(k,j,tn) ) ) * ddx       &
+                     + ( ( flux_n(k) + diss_n(k) )                             &
+                     -   ( flux_s_v(k,tn) + diss_s_v(k,tn) ) ) * ddy           &
+                     + ( ( flux_t(k) + diss_t(k) )                             &
+                     -   ( flux_d + diss_d ) ) * drho_air(k) * ddzw(k)         &
+                                            )  + v(k,j,i) * div
+
+#ifndef _OPENACC
+!
+!--             Swap fluxes. Note, in the OPENACC case these are computed again.
+                flux_l_v(k,j,tn) = flux_r(k)
+                diss_l_v(k,j,tn) = diss_r(k)
+                flux_s_v(k,tn)   = flux_n(k)
+                diss_s_v(k,tn)   = diss_n(k)
+#endif
+
+!
+!--             Statistical Evaluation of v'v'. The factor has to be applied
+!--             for right evaluation when gallilei_trans = .T. .
+                !$ACC ATOMIC
+                sums_vs2_ws_l(k,tn) = sums_vs2_ws_l(k,tn)                      &
+                + ( flux_n(k)                                                  &
+                    * ( v_comp(k) - 2.0_wp * hom(k,1,2,0)                   )  &
+                    / ( v_comp(k) - gv + SIGN( 1.0E-20_wp, v_comp(k) - gv ) )  &
+               +   diss_n(k)                                                   &
+                    *   ABS( v_comp(k) - 2.0_wp * hom(k,1,2,0)              )  &
+                    / ( ABS( v_comp(k) - gv ) + 1.0E-20_wp                  )  &
+                  ) *   weight_substep(intermediate_timestep_count)
+!
+!--             Statistical Evaluation of w'u'.
+                !$ACC ATOMIC
+                sums_wsvs_ws_l(k,tn) = sums_wsvs_ws_l(k,tn)                    &
+                + ( flux_t(k)                                                  &
+                    * ( w_comp(k) - 2.0_wp * hom(k,1,3,0)                   )  &
+                    / ( w_comp(k) + SIGN( 1.0E-20_wp, w_comp(k) )           )  &
+               +   diss_t(k)                                                   &
+                    *   ABS( w_comp(k) - 2.0_wp * hom(k,1,3,0)              )  &
+                    / ( ABS( w_comp(k) ) + 1.0E-20_wp                       )  &
+                  ) *   weight_substep(intermediate_timestep_count)
+
+             ENDDO
+
           ENDDO
        ENDDO
 
+       CALL cpu_log( log_point_s(69), 'advec_v_ws', 'stop' )
+
     END SUBROUTINE advec_v_ws
-    
-    
+
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -5876,7 +5950,7 @@
        INTEGER(iwp) ::  k_pp      !< k+2 index in disretization, can be modified to avoid segmentation faults
        INTEGER(iwp) ::  k_ppp     !< k+3 index in disretization, can be modified to avoid segmentation faults
-       INTEGER(iwp) ::  nzb_max_l !< index indicating upper bound for order degradation of horizontal advection terms  
+       INTEGER(iwp) ::  nzb_max_l !< index indicating upper bound for order degradation of horizontal advection terms
        INTEGER(iwp) ::  tn = 0    !< number of OpenMP thread
-       
+
        REAL(wp)    ::  ibit18 !< flag indicating 1st-order scheme along x-direction
        REAL(wp)    ::  ibit19 !< flag indicating 3rd-order scheme along x-direction
@@ -5895,74 +5969,76 @@
        REAL(wp)    ::  ibit23_s !< flag indicating 5th-order scheme along y-direction
 #endif
-       REAL(wp)    ::  ibit24 !< flag indicating 1st-order scheme along z-direction
-       REAL(wp)    ::  ibit25 !< flag indicating 3rd-order scheme along z-direction
-       REAL(wp)    ::  ibit26 !< flag indicating 5th-order scheme along z-direction
-       REAL(wp)    ::  diss_d !< artificial dissipation term at grid box bottom
-       REAL(wp)    ::  div    !< divergence on w-grid
-       REAL(wp)    ::  flux_d !< 6th-order flux at grid box bottom
-       REAL(wp)    ::  gu     !< Galilei-transformation velocity along x
-       REAL(wp)    ::  gv     !< Galilei-transformation velocity along y
-       REAL(wp)    ::  u_comp !< advection velocity along x
+       REAL(wp)    ::  ibit24   !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)    ::  ibit25   !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)    ::  ibit26   !< flag indicating 5th-order scheme along z-direction
+       REAL(wp)    ::  diss_d   !< artificial dissipation term at grid box bottom
+       REAL(wp)    ::  div      !< divergence on w-grid
+       REAL(wp)    ::  flux_d   !< 6th-order flux at grid box bottom
+       REAL(wp)    ::  gu       !< Galilei-transformation velocity along x
+       REAL(wp)    ::  gv       !< Galilei-transformation velocity along y
 #ifdef _OPENACC
        REAL(wp)    ::  u_comp_l !< advection velocity along x
-#endif
-       REAL(wp)    ::  v_comp !< advection velocity along y
-#ifdef _OPENACC
        REAL(wp)    ::  v_comp_s !< advection velocity along y
 #endif
-       REAL(wp)    ::  w_comp !< advection velocity along z
-       
-       REAL(wp)    ::  diss_t !< discretized artificial dissipation at top of the grid box
-       REAL(wp)    ::  flux_t !< discretized 6th-order flux at top of the grid box
-       
-       REAL(wp)    ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
-       REAL(wp)    ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
-       REAL(wp)    ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
-       REAL(wp)    ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
-
-       REAL(wp)    ::  diss_s !< discretized artificial dissipation at southward-side of the grid box
-       REAL(wp)    ::  flux_s !< discretized 6th-order flux at southward-side of the grid box
-#ifndef _OPENACC
-       REAL(wp), DIMENSION(nzb+1:nzt)  ::  swap_diss_y_local_w !< discretized artificial dissipation at southward-side of the grid box
-       REAL(wp), DIMENSION(nzb+1:nzt)  ::  swap_flux_y_local_w !< discretized 6th-order flux at southward-side of the grid box
-#endif
-       
-       REAL(wp)    ::  diss_l !< discretized artificial dissipation at leftward-side of the grid box
-       REAL(wp)    ::  flux_l !< discretized 6th-order flux at leftward-side of the grid box
-#ifndef _OPENACC
-       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_diss_x_local_w !< discretized artificial dissipation at leftward-side of the grid box
-       REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_flux_x_local_w !< discretized 6th-order flux at leftward-side of the grid box
-#endif
-!
-!--    Set local version of nzb_max. At non-cyclic boundaries the order of the 
-!--    advection need to be degraded near the boundary. Please note, in contrast
-!--    to the cache-optimized routines, nzb_max_l is set constantly for the 
-!--    entire subdomain, in order to avoid unsymmetric loops which might be 
-!--    an issue for GPUs.
-       IF( bc_dirichlet_l  .OR.  bc_radiation_l  .OR.                          &
-           bc_dirichlet_r  .OR.  bc_radiation_r  .OR.                          &
-           bc_dirichlet_s  .OR.  bc_radiation_s  .OR.                          &
-           bc_dirichlet_n  .OR.  bc_radiation_n )  THEN
-          nzb_max_l = nzt
-       ELSE
-          nzb_max_l = nzb_max
-       END IF
-       
+
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  diss_t !< discretized artificial dissipation at top of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  flux_t !< discretized 6th-order flux at top of the grid box
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  u_comp !< advection velocity along x
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  v_comp !< advection velocity along y
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  w_comp !< advection velocity along z
+
+
+       CALL cpu_log( log_point_s(87), 'advec_w_ws', 'start' )
+
        gu = 2.0_wp * u_gtrans
        gv = 2.0_wp * v_gtrans
 
+       !$ACC PARALLEL LOOP COLLAPSE(2) FIRSTPRIVATE(tn, gu, gv) &
+       !$ACC PRIVATE(i, j, k, k_mm, k_pp, k_ppp) &
+       !$ACC PRIVATE(ibit18, ibit19, ibit20, ibit21, ibit22, ibit23) &
+       !$ACC PRIVATE(ibit24, ibit25, ibit26) &
+       !$ACC PRIVATE(ibit18_l, ibit19_l, ibit20_l) &
+       !$ACC PRIVATE(ibit21_s, ibit22_s, ibit23_s) &
+       !$ACC PRIVATE(flux_r, diss_r) &
+       !$ACC PRIVATE(flux_n, diss_n) &
+       !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
+       !$ACC PRIVATE(flux_l_w, diss_l_w, flux_s_w, diss_s_w) &
+       !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s, w_comp) &
+       !$ACC PRESENT(advc_flags_m) &
+       !$ACC PRESENT(u, v, w) &
+       !$ACC PRESENT(drho_air, rho_air_zw, ddzw) &
+       !$ACC PRESENT(tend) &
+       !$ACC PRESENT(hom(:,1,1:3,0)) &
+       !$ACC PRESENT(weight_substep(intermediate_timestep_count)) &
+       !$ACC PRESENT(sums_ws2_ws_l)
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+!
+!--          Used local modified copy of nzb_max (used to degrade order of
+!--          discretization) at non-cyclic boundaries. Modify only at relevant points
+!--          instead of the entire subdomain. This should lead to better
+!--          load balance between boundary and non-boundary PEs.
+             IF( ( bc_dirichlet_l  .OR.  bc_radiation_l )  .AND.  i <= nxl + 2  .OR. &
+                 ( bc_dirichlet_r  .OR.  bc_radiation_r )  .AND.  i >= nxr - 2  .OR. &
+                 ( bc_dirichlet_s  .OR.  bc_radiation_s )  .AND.  j <= nys + 2  .OR. &
+                 ( bc_dirichlet_n  .OR.  bc_radiation_n )  .AND.  j >= nyn - 2 )  THEN
+                nzb_max_l = nzt
+             ELSE
+                nzb_max_l = nzb_max
+             END IF
+
 #ifndef _OPENACC
-!
-!--   compute the whole left boundary of the processor domain
-       i = nxl
-       DO  j = nys, nyn
-          DO  k = nzb+1, nzb_max_l
-
-             ibit20 = REAL( IBITS(advc_flags_m(k,j,i-1),20,1), KIND = wp )
-             ibit19 = REAL( IBITS(advc_flags_m(k,j,i-1),19,1), KIND = wp )
-             ibit18 = REAL( IBITS(advc_flags_m(k,j,i-1),18,1), KIND = wp )
-
-             u_comp                   = u(k+1,j,i) + u(k,j,i) - gu
-             swap_flux_x_local_w(k,j) = u_comp * (                             &
+             IF ( i == nxl )  THEN
+                DO  k = nzb+1, nzb_max_l
+                   ibit20 = REAL( IBITS(advc_flags_m(k,j,i-1),20,1), KIND = wp )
+                   ibit19 = REAL( IBITS(advc_flags_m(k,j,i-1),19,1), KIND = wp )
+                   ibit18 = REAL( IBITS(advc_flags_m(k,j,i-1),18,1), KIND = wp )
+
+                   u_comp(k)        = u(k+1,j,i) + u(k,j,i) - gu
+                   flux_l_w(k,j,tn) = u_comp(k) * (                            &
                                       ( 37.0_wp * ibit20 * adv_mom_5           &
                                    +     7.0_wp * ibit19 * adv_mom_3           &
@@ -5977,7 +6053,7 @@
                                       ) *                                      &
                                      ( w(k,j,i+2) + w(k,j,i-3) )               &
-                                                 )
-
-               swap_diss_x_local_w(k,j) = - ABS( u_comp ) * (                  &
+                                                  )
+
+                   diss_l_w(k,j,tn) = - ABS( u_comp(k) ) * (                   &
                                         ( 10.0_wp * ibit20 * adv_mom_5         &
                                      +     3.0_wp * ibit19 * adv_mom_3         &
